/****************************************************************************
                  INTERNATIONAL AVS CENTER
	(This disclaimer must remain at the top of all files)

WARRANTY DISCLAIMER

This module and the files associated with it are distributed free of charge.
It is placed in the public domain and permission is granted for anyone to use,
duplicate, modify, and redistribute it unless otherwise noted.  Some modules
may be copyrighted.  You agree to abide by the conditions also included in
the AVS Licensing Agreement, version 1.0, located in the main module
directory located at the International AVS Center ftp site and to include
the AVS Licensing Agreement when you distribute any files downloaded from 
that site.

The International AVS Center, MCNC, the AVS Consortium and the individual
submitting the module and files associated with said module provide absolutely
NO WARRANTY OF ANY KIND with respect to this software.  The entire risk as to
the quality and performance of this software is with the user.  IN NO EVENT
WILL The International AVS Center, MCNC, the AVS Consortium and the individual
submitting the module and files associated with said module BE LIABLE TO
ANYONE FOR ANY DAMAGES ARISING FROM THE USE OF THIS SOFTWARE, INCLUDING,
WITHOUT LIMITATION, DAMAGES RESULTING FROM LOST DATA OR LOST PROFITS, OR ANY
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES.

This AVS module and associated files are public domain software unless
otherwise noted.  Permission is hereby granted to do whatever you like with
it, subject to the conditions that may exist in copyrighted materials. Should
you wish to make a contribution toward the improvement, modification, or
general performance of this module, please send us your comments:  why you
liked or disliked it, how you use it, and most important, how it helps your
work. We will receive your comments at avs@ncsc.org.

Please send AVS module bug reports to avs@ncsc.org.

******************************************************************************/
/* mod_gen Version 1                                                     */
/* Module Name: "read jpeg" (Input) (Subroutine)                         */
/* Author: John W. Langner                                               */
/* Date Created: Wed Oct 23 16:17:00 1991                                */
/*                                                                       */
/* This file is automatically generated by the Module Generator (mod_gen)*/
/* Please do not modify or move the contents of this comment block as    */
/* mod_gen needs it in order to read module sources back in.             */
/*                                                                       */
/* output 0 "AVS image out" field 2D 2-space 4-vector uniform byte       */
/* param 0 "JPEG Input File Name" browser                                */
/* param 1 "Cross Block Smoothing" toggle 0 0 1                          */
/* End of Module Description Comments                                    */

#define _MEM_DEFS_defined 1		/* disable memory checking routines */

#include <stdio.h>
#include <avs/avs.h>
#include <avs/port.h>
#include <avs/field.h>
 
/* ----> START OF USER-SUPPLIED CODE SECTION #1 (INCLUDE FILES, GLOBAL VARIABLES)*/

/*
 * DISCLAIMER
 * ==========
 *
 * THIS SOFTWARE IS NOT COMPLETE NOR FULLY DEBUGGED.  It is not guaranteed to be
 * useful for anything, nor to be compatible with subsequent releases, nor to be
 * an accurate implementation of the JPEG standard.  (See LEGAL ISSUES for even
 * more disclaimers.)
 */

#include "jinclude.h"
#include <setjmp.h>

extern char *getenv();
/* ABS 07/16/04
extern unsigned char *AVSfield_data_ptr();
*/

static void d_ui_method_selection ();
METHODDEF int read_jpeg_data ();
void jselwavs ();

static jmp_buf error_recovery_env;
static AVSfield_char **global_out_field_ptr;
static int next_row_out;


/* <---- END OF USER-SUPPLIED CODE SECTION #1                            */
 
/* *****************************************/
/*  Module Specification                   */
/* *****************************************/
int read_jpeg_spec()
{

	int in_port, out_port, param;
	extern int read_jpeg_compute();

	AVSset_module_name("read jpeg", MODULE_DATA);

	/* Output Port Specifications              */
	out_port = AVScreate_output_port("AVS image out", 
		"field 2D 2-space 4-vector uniform byte");

	/* Parameter Specifications                */
	param = AVSadd_parameter("JPEG Input File Name", "string", " ", " ", 
		" ");
	AVSconnect_widget(param, "browser");
	param = AVSadd_parameter("Cross Block Smoothing", "boolean", 0, 0, 1);
	AVSconnect_widget(param, "toggle");

	AVSset_compute_proc(read_jpeg_compute);
/* ----> START OF USER-SUPPLIED CODE SECTION #2 (ADDITIONAL SPECIFICATION INFO)*/
/* <---- END OF USER-SUPPLIED CODE SECTION #2                            */
	return(1);
}
 
/* *****************************************/
/* Module Compute Routine                  */
/* *****************************************/
int read_jpeg_compute( AVS_image_out, JPEG_Input_File_Name, 
Cross_Block_Smoothing)
	AVSfield_char **AVS_image_out;
	char *JPEG_Input_File_Name;
	int Cross_Block_Smoothing;
{

/*  THIS IS A 'HINTS' AREA - YOU MAY CUT AND PASTE AT WILL FROM IT       */
/*                                                                       */
/* 	int dims0[2];                                                        */
/*                                                                       */
/* Free old field data                                                   */
/* 	if (*AVS_image_out) AVSfield_free(*AVS_image_out);                   */
/* Allocate space for new field output                                   */
/* 	dims0[0] = <<FILL_IN_DIMENSIONS_HERE!>>                              */
/* 	dims0[1] = <<FILL_IN_DIMENSIONS_HERE!>>                              */
/* 	*AVS_image_out = (AVSfield_char *) AVSdata_alloc("field 2D 2-space 4-vector uniform byte", dims0);*/
/*  FILL IN THE OUTPUT FIELD  Here!                                      */
/* free any locally allocated data                                       */
/* THIS IS THE END OF THE 'HINTS' AREA. ADD YOUR OWN CODE BETWEEN THE    */
/* FOLLOWING COMMENTS. THE CODE YOU SUPPLY WILL NOT BE OVERWRITTEN.      */
 
/* ----> START OF USER-SUPPLIED CODE SECTION #3 (COMPUTE ROUTINE BODY)   */


/*--------------------------------------------------------------------------
 *
 * Parts of this are based on:
 *
 * jdmain.c			last edit:  tgl  11-Aug-91
 *
 * Shoehorned in some differences found in later version 1 which contained:
 *
 * Copyright (C) 1991, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 *--------------------------------------------------------------------------*/


  struct decompress_info_struct cinfo;
  struct decompress_methods_struct dc_methods;
  struct external_methods_struct e_methods;
  int c;
  char *p;


/* 
 * Free old field data, if any.
 */
  if (*AVS_image_out) {
      AVSfield_free(*AVS_image_out);                   
      *AVS_image_out = NULL;
  }
  global_out_field_ptr = AVS_image_out;

/* 
 * Try to open input file.
 */
  if (JPEG_Input_File_Name == NULL || 
		*JPEG_Input_File_Name == '\0' ||
		*JPEG_Input_File_Name == ' ') {
      return (0);
  }

  cinfo.input_file = fopen (JPEG_Input_File_Name, "r");
  if (cinfo.input_file == NULL) {
      AVSerror ("Can't open input file:\n'%s'", JPEG_Input_File_Name);
      return (0);
  }

/* 
 * ERREXIT will display dialog box with message then come here.
 */
  if (setjmp (error_recovery_env) != 0) {
      fclose (cinfo.input_file);
      return (0);	/* failure */
  }

/* 
 * Initialize the system-dependent method pointers. 
 */
  cinfo.methods = &dc_methods;
  cinfo.emethods = &e_methods;
  jselerror(&e_methods);	/* error/trace message routines */
  jselvirtmem(&e_methods);	/* memory allocation routines */
  dc_methods.d_ui_method_selection = d_ui_method_selection;
  dc_methods.read_jpeg_data = read_jpeg_data;

  /* Allocate memory for input buffer. */
  cinfo.input_buffer = (char *) (*cinfo.emethods->alloc_small)
				    ((size_t) (JPEG_BUF_SIZE + MIN_UNGET));
  cinfo.bytes_in_buffer = 0;    /* initialize buffer to empty */

  cinfo.output_file = NULL;	/* not used in AVS case */

/* 
 * Set up parameters. 
 */
  e_methods.trace_level = 0;
  cinfo.output_gamma = 1.0;
  cinfo.quantize_colors = FALSE;
  cinfo.two_pass_quantize = FALSE;
  cinfo.use_dithering = FALSE;
  cinfo.desired_number_of_colors = 0;
  cinfo.do_block_smoothing = Cross_Block_Smoothing;
  cinfo.do_pixel_smoothing = FALSE;
  cinfo.out_color_space = CS_RGB;
  cinfo.jpeg_color_space = CS_UNKNOWN;
  /* setting any other value in jpeg_color_space overrides heuristics */
  /* in jrdjfif.c ... */

/*
 * Debug output.
 */
  p = getenv("AVS_JPEG_DEBUG");
  if (p != NULL)
      e_methods.trace_level = atoi(p);

/* 
 * Set up to read a JFIF or baseline-JPEG file.
 * A smarter UI would inspect the first few bytes of the input file 
 * to determine its type. 
 */
#ifdef JFIF_SUPPORTED
  jselrjfif(&cinfo);
#else
  ERREXIT(cinfo->emethods, "You shoulda defined JFIF_SUPPORTED");
#endif

/* 
 * Do it to it! 
 */
  jpeg_decompress(&cinfo);
  
  fclose (cinfo.input_file);

/* 
 * Release memory. 
 */
  (*cinfo.emethods->free_small) ((void *) cinfo.input_buffer);

#ifdef MEM_STATS
  if (e_methods.trace_level > 0)
    j_mem_stats();
#endif

/* <---- END OF USER-SUPPLIED CODE SECTION #3                            */
	return(1);
}
 
/* ***********************************************************************/
/* Initialization for modules contained in this file.                    */
/* ***********************************************************************/
int ((*filter_mod_list[])()) = {
	read_jpeg_spec,
};
#define NMODS (sizeof(filter_mod_list) / sizeof(char *))

AVSinit_modules()
{
	AVSinit_from_module_list(filter_mod_list, NMODS);
}
 
/* ----> START OF USER-SUPPLIED CODE SECTION #4 (SUBROUTINES, FUNCTIONS, UTILITY ROUTINES)*/
/*
 * This routine gets control after the input file header has been read.
 * It must determine what output file format is to be written,
 * and make any other decompression parameter changes that are desirable.
 */

static void
d_ui_method_selection (decompress_info_ptr cinfo)
{
  /* select output colorspace */
  if (cinfo->jpeg_color_space == CS_GRAYSCALE)
    cinfo->out_color_space = CS_GRAYSCALE;
  else
    cinfo->out_color_space = CS_RGB;
  
  jselwavs(cinfo);
}

/*
 * Reload the input buffer after it's been emptied, and return the next byte.
 * See the JGETC macro for calling conditions.
 *
 * This routine would need to be replaced if reading JPEG data from something
 * other than a stdio stream.
 */

METHODDEF int
read_jpeg_data (decompress_info_ptr cinfo)
{
  cinfo->bytes_in_buffer = fread(cinfo->input_buffer + MIN_UNGET,
				 1, JPEG_BUF_SIZE,
				  cinfo->input_file);

  cinfo->next_input_byte = cinfo->input_buffer + MIN_UNGET;

  if (cinfo->bytes_in_buffer <= 0)
    ERREXIT(cinfo->emethods, "Unexpected EOF in JPEG file");

  return JGETC(cinfo);
}


/*-------------------------------------------------------------------------
 *
 * Derived from:
 *
 * jwrppm.c			last edit:  tgl  11-Aug-91
 *
 * These are routines to store decompressed output into an AVS field.
 *
 * These routines are invoked via the methods put_pixel_rows, put_color_map,
 * and output_init/term.
 *
 *-------------------------------------------------------------------------*/


/*
 * Write the file header.
 * In the AVS case we allocate space for output field.
 * Can't do it before reading file because we don't know
 * how big to make it.
 */

static void
output_init (decompress_info_ptr cinfo)
{
  int dims0[2];

  if (cinfo->out_color_space == CS_GRAYSCALE ||
              cinfo->out_color_space == CS_RGB) {

      dims0[0] = cinfo->image_width;
      dims0[1] = cinfo->image_height;
      *global_out_field_ptr = (AVSfield_char *) 
	      AVSdata_alloc("field 2D 2-space 4-vector uniform byte", dims0);
      AVSfield_set_labels (*global_out_field_ptr, "alpha;red;green;blue", ";");

      next_row_out = 0;

  } else {
    ERREXIT(cinfo->emethods, "output must be grayscale or RGB");
  }
}


/*
 * Write the color map.
 * There is no color map; result is 24 bit pixels.
 */

static void
put_color_map (decompress_info_ptr cinfo, int num_colors, JSAMPARRAY colormap)
{
}


/*
 * Write some pixel data.
 * Note that this is called for partial images so we must
 * keep track of where we are.
 */

static void
put_pixel_rows (decompress_info_ptr cinfo, int num_rows,
		JSAMPIMAGE pixel_data)
{
  register JSAMPROW ptr0, ptr1, ptr2;
  register long col;
  register long width = cinfo->image_width;
  register int row;
  register unsigned char *pdata;


  pdata = AVSfield_data_ptr(*global_out_field_ptr);
  pdata += next_row_out * width * 4;
  next_row_out += num_rows;

  if (cinfo->out_color_space == CS_GRAYSCALE) {
    for (row = 0; row < num_rows; row++) {
      ptr0 = pixel_data[0][row];
      for (col = 0; col < width; col++) {
	pdata[AVS_ALPHA_BYTE] = 0;
	pdata[AVS_RED_BYTE] = *ptr0;
	pdata[AVS_GREEN_BYTE] = *ptr0;
	pdata[AVS_BLUE_BYTE] = *ptr0;
	pdata += 4;
	ptr0++;
      }
    }
  } else {
    for (row = 0; row < num_rows; row++) {
      ptr0 = pixel_data[0][row];
      ptr1 = pixel_data[1][row];
      ptr2 = pixel_data[2][row];
      for (col = 0; col < width; col++) {
	pdata[AVS_ALPHA_BYTE] = 0;
	pdata[AVS_RED_BYTE] = *ptr0++;
	pdata[AVS_GREEN_BYTE] = *ptr1++;
	pdata[AVS_BLUE_BYTE] = *ptr2++;
	pdata += 4;
      }
    }
  }
}


/*
 * Finish up at the end of the file.
 */

static void
output_term (decompress_info_ptr cinfo)
{
  /* no work required */
}


/*
 * The method selection routine for AVS field output.
 * This should be called from d_ui_method_selection.
 */

void
jselwavs (decompress_info_ptr cinfo)
{
  cinfo->methods->output_init = output_init;
  cinfo->methods->put_color_map = put_color_map;
  cinfo->methods->put_pixel_rows = put_pixel_rows;
  cinfo->methods->output_term = output_term;
}

/*--------------------------------------------------------------------------
 *
 * Based on:
 *
 * jerror.c			last edit:  tgl  4-Jul-91
 *
 * This file is part of the portable JPEG software.
 *
 * This file contains simple error-reporting and trace-message routines.
 * These are suitable for Unix-like systems and others where writing to
 * stderr is the right thing to do.  If the JPEG software is integrated
 * into a larger application, you may well need to replace these.
 *
 * The error_exit() routine should not return to its caller.  Within a
 * larger application, you might want to have it do a longjmp() to return
 * control to the outer user interface routine.  This should work since
 * the portable JPEG code doesn't use setjmp/longjmp.  However, this won't
 * release allocated memory or close temp files --- some bookkeeping would
 * need to be added to the memory manager module to make that work.
 *
 * These routines are used by both the compression and decompression code.
 *
 *-------------------------------------------------------------------------*/

static external_methods_ptr methods; /* saved for access to message_parm */


static void
trace_message (char *msgtext)
{
  fprintf(stderr, msgtext,
	  methods->message_parm[0], methods->message_parm[1],
	  methods->message_parm[2], methods->message_parm[3],
	  methods->message_parm[4], methods->message_parm[5],
	  methods->message_parm[6], methods->message_parm[7]);
  fprintf(stderr, "\n");
}

/*
 * Display a dialog box with error message.
 * Jump back to module's compute function.
 */
static void
error_exit (char *msgtext)
{
  AVSerror (msgtext,
	  methods->message_parm[0], methods->message_parm[1],
	  methods->message_parm[2], methods->message_parm[3],
	  methods->message_parm[4], methods->message_parm[5]);
  longjmp (error_recovery_env, 1);
}


/*
 * The method selection routine for simple error handling.
 * The system-dependent setup routine should call this routine
 * to install the necessary method pointers in the supplied struct.
 */

void
jselerror (external_methods_ptr emethods)
{
  methods = emethods;		/* save struct addr for msg parm access */

  emethods->error_exit = error_exit;
  emethods->trace_message = trace_message;

  emethods->trace_level = 0;	/* default = no tracing */
}
/* <---- END OF USER-SUPPLIED CODE SECTION #4                            */
